Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1878858 - kernel 5.8.8 changes the return code for partition operations and breaks parted
Summary: kernel 5.8.8 changes the return code for partition operations and breaks parted
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel
Version: 32
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Kernel Maintainer List
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard: openqa
: 1879046 1879287 1880203 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-09-14 17:39 UTC by Brian Lane
Modified: 2021-05-25 16:44 UTC (History)
23 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-05-25 16:44:21 UTC
Type: Bug


Attachments (Terms of Use)

Description Brian Lane 2020-09-14 17:39:05 UTC
1. Please describe the problem:
Running parted (eg. partprobe) on kernel 5.8.8 results in errors as it tries to add unknown partitions:

Error: Partition(s) 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64 on /dev/sda have been written, but we have been unable to inform the kernel of the change, probably because it/they are in use.  As a result, the old partition(s) will remain in use.  You should reboot now before making further changes.

FYI this is how parted/partprobe works, it expects a return code of ENXIO for the missing partitions. This has been changed to ENOMEM by the refactoring of things into block/partitions/core.c

https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/log/block/partitions/core.c

I *think* this may be fixed in rc5 by this commit:

https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/block/partitions/core.c?id=88ce2a530cc9865a894454b2e40eba5957a60e1a

but I am unable to confirm this myself.


2. What is the Version-Release number of the kernel:
kernel-5.8.8-200 and later (also tested  kernel-5.9.0-0.rc4.20200911git581cb3a26baf.8.fc34 on rawhide which has the same problem)


3. Did it work previously in Fedora? If so, what kernel version did the issue
   *first* appear?  Old kernels are available for download at
   https://koji.fedoraproject.org/koji/packageinfo?packageID=8 :

Yes. Started failing on kernel-5.8.8, works fine on kernel-5.8.7-200 and older.

4. Can you reproduce this issue? If so, please provide the steps to reproduce
   the issue below:

Yes. Run 'partprobe' to demonstrate the problem. There should be no output.


5. Does this problem occur with the latest Rawhide kernel? To install the
   Rawhide kernel, run ``sudo dnf install fedora-repos-rawhide`` followed by
   ``sudo dnf update --enablerepo=rawhide kernel``:

Yes, using any kernel newer than 5.8.7

6. Are you running any modules that not shipped with directly Fedora's kernel?:

No.

7. Please attach the kernel logs. You can get the complete kernel log
   for a boot with ``journalctl --no-hostname -k > dmesg.txt``. If the
   issue occurred on a previous boot, use the journalctl ``-b`` flag.

Relevant strace output from 5.8.8-200:

ioctl(3, BLKPG, {op=BLKPG_DEL_PARTITION, flags=0, datalen=152, data={start=0, length=0, pno=4, devname="", volname=""}}) = -1 ENOMEM (Cannot allocate memory)
ioctl(3, BLKPG, {op=BLKPG_DEL_PARTITION, flags=0, datalen=152, data={start=0, length=0, pno=5, devname="", volname=""}}) = -1 ENOMEM (Cannot allocate memory)

(it repeats this up to partition 256).


On 5.8.7-200 it looks like this:

ioctl(3, BLKPG, {op=BLKPG_DEL_PARTITION, flags=0, datalen=152, data={start=0, length=0, pno=4, devname="", volname=""}}) = -1 ENXIO (No such device or address)
ioctl(3, BLKPG, {op=BLKPG_DEL_PARTITION, flags=0, datalen=152, data={start=0, length=0, pno=5, devname="", volname=""}}) = -1 ENXIO (No such device or address)

etc.

Comment 1 Adam Williamson 2020-09-14 21:12:49 UTC
yeah, openQA ran into this while testing the kernel updates:

https://openqa.fedoraproject.org/tests/overview?distri=fedora&version=32&build=Update-FEDORA-2020-d6ab6157a6&groupid=2
https://openqa.fedoraproject.org/tests/overview?distri=fedora&version=33&build=Update-FEDORA-2020-5747e0b16a&groupid=2
https://openqa.fedoraproject.org/tests/overview?distri=fedora&version=31&build=Update-FEDORA-2020-d807dc4d9d&groupid=2

there are four install tests run per update (one BIOS and one UEFI for each of a netinst and a live image), all four failed on each of the three updates, and the failure looks exactly like this bug:

dasbus.error.DBusError: Partition(s) 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64 on /dev/vda have been written, but we have been unable to inform the kernel of the change, probably because it/they are in use.  As a result, the old partition(s) will remain in use.  You should reboot now before making further changes.

Comment 2 Fedora Update System 2020-09-15 00:19:46 UTC
FEDORA-2020-450fc40117 has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2020-450fc40117

Comment 3 Fedora Update System 2020-09-15 00:20:17 UTC
FEDORA-2020-3c6fedeb83 has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-3c6fedeb83

Comment 4 Fedora Update System 2020-09-15 00:20:38 UTC
FEDORA-2020-5920a7a0b2 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-5920a7a0b2

Comment 5 Fedora Update System 2020-09-15 14:54:03 UTC
FEDORA-2020-450fc40117 has been pushed to the Fedora 33 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2020-450fc40117`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-450fc40117

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 6 Brian Lane 2020-09-15 15:43:00 UTC
*** Bug 1879046 has been marked as a duplicate of this bug. ***

Comment 7 Fedora Update System 2020-09-15 16:22:05 UTC
FEDORA-2020-5920a7a0b2 has been pushed to the Fedora 31 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2020-5920a7a0b2`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-5920a7a0b2

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 8 Fedora Update System 2020-09-15 16:23:25 UTC
FEDORA-2020-3c6fedeb83 has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2020-3c6fedeb83`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-3c6fedeb83

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 9 Michael Riss 2020-09-15 21:20:25 UTC
*** Bug 1879287 has been marked as a duplicate of this bug. ***

Comment 10 Fedora Update System 2020-09-16 14:40:08 UTC
FEDORA-2020-5920a7a0b2 has been pushed to the Fedora 31 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 11 Fedora Update System 2020-09-16 14:44:30 UTC
FEDORA-2020-3c6fedeb83 has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 12 Vojtech Trefny 2020-09-18 04:59:04 UTC
*** Bug 1880203 has been marked as a duplicate of this bug. ***

Comment 13 Fedora Program Management 2021-04-29 16:37:41 UTC
This message is a reminder that Fedora 32 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 32 on 2021-05-25.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '32'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 32 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 14 Ben Cotton 2021-05-25 16:44:21 UTC
Fedora 32 changed to end-of-life (EOL) status on 2021-05-25. Fedora 32 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.